SystemOrganization addCategory: #'Glamour-Tests-Rubric'!

GLMMorphicTest subclass: #GLMRubricTextMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Rubric'!

!GLMRubricTextMorphicTest methodsFor: 'private' stamp: 'TudorGirba 7/16/2013 21:52'!
simulateOnlyOneClickOn: aMorph
	(Delay forMilliseconds: HandMorph doubleClickTime + 1) wait.
	aMorph simulateClick! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 8/2/2013 22:11'!
testAcceptKeyCanBeOverriden
	| composite textMorph overriden |
	overriden := false.
	composite := GLMCompositePresentation new with: [ :a | a rubricText act: [ :text | overriden := true ] on: $s entitled: 'Override'].
	window := composite openOn: '4'.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStroke: $s command.
	self assert: overriden.! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/16/2013 21:52'!
testEnteringTextInPort
	| composite textMorph |
	composite := GLMCompositePresentation new with: [ :a | a rubricText display: '' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStrokes: 'hello'.
	self assert: (composite pane port: #text) value asString equals: 'hello'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/16/2013 21:52'!
testExplicitAcceptDoesNotAffectTextPort
	| composite textMorph |
	composite := GLMCompositePresentation new with: [ :a | a rubricText display: '123' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStrokes: '4'.
	self assert: (composite pane port: #text) value asString equals: '1234'.
	self simulateKeyStroke: $s command.
	self simulateKeyStrokes: '56'.
	self assert: (composite pane port: #text) value asString equals: '123456'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 6/5/2013 23:19'!
testMultipleSelectionWithChange
	| composite textMorph textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a rubricText display: '123456789' ].
	window := composite openOn: 4.
	textMorph := self find: RubScrolledTextMorph in: window.
	self assert: textMorph selectionInterval isEmpty.
	textPresentation := composite presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self assert: textMorph textArea selection asString equals: '2345'.
	self assert: textPresentation selectedText asString equals: '2345'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/16/2013 21:52'!
testPastingUpdatesTextPort
	| composite textMorph |
	composite := GLMCompositePresentation new with: [ :a | a rubricText display: '' ].
	window := composite openOn: 42.
	textMorph := self find: RubScrolledTextMorph in: window.
	Clipboard clipboardText: '42'.
	self simulateOnlyOneClickOn: textMorph.
	self simulateKeyStroke: $v command.
	self assert: (composite pane port: #text) value asString equals: '42'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 6/5/2013 23:18'!
testResettingTheSelection
	| composite textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a rubricText display: '123456789' ].
	window := composite openOn: 4.
	textPresentation := composite presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self shouldnt: [textPresentation selectionInterval: nil] raise: Error! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 6/5/2013 23:20'!
testTextPortPopulatedByDefault
	| composite |
	composite := GLMCompositePresentation new with: [:a | a rubricText ].
	window := composite openOn: '42'.
	self assert: (composite pane port: #text) value asString equals: '42'! !

!GLMRubricTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 8/2/2013 22:12'!
testUnregisterFromAnnouncementsWhenUpdating
	| composite announcingCollection numberOfExecutions |
	numberOfExecutions := 0.
	announcingCollection := GLMAnnouncingCollection new.
	composite :=  GLMCompositePresentation new with: [ :a | 
					(a rubricText)
						updateOn: GLMItemAdded from: [ announcingCollection ];
						display: [ 
								numberOfExecutions := numberOfExecutions + 1. 
								numberOfExecutions asString ] ].
	window := composite openOn: announcingCollection.
	1 to: 3 do: [ :each | announcingCollection add: each ].
	self assert: numberOfExecutions equals: 4	"it should not be 8"! !
